# coding: utf-8

"""
    Lilt REST API

    Lilt REST API Support: https://lilt.atlassian.net/servicedesk/customer/portals    The Lilt REST API enables programmatic access to the full-range of Lilt backend services including:   * Training of and translating with interactive, adaptive machine translation   * Large-scale translation memory   * The Lexicon (a large-scale termbase)   * Programmatic control of the Lilt CAT environment   * Translation memory synchronization  Requests and responses are in JSON format. The REST API only responds to HTTPS / SSL requests.  The base url for this REST API is `https://api.lilt.com/`.  ## Authentication  Requests are authenticated via REST API key, which requires the Business plan.  Requests are authenticated using [HTTP Basic Auth](https://en.wikipedia.org/wiki/Basic_access_authentication). Add your REST API key as both the `username` and `password`.  For development, you may also pass the REST API key via the `key` query parameter. This is less secure than HTTP Basic Auth, and is not recommended for production use.  ## Quotas  Our services have a general quota of 4000 requests per minute. Should you hit the maximum requests per minute, you will need to wait 60 seconds before you can send another request.   # noqa: E501

    The version of the OpenAPI document: v3.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from lilt.configuration import Configuration


class LiltCreateContent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'id': 'int',
        'language': 'str',
        'template': 'str',
        'template_params': 'LiltCreateContentTemplateParams',
        'preferences': 'LiltCreateContentPreferences'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'language': 'language',
        'template': 'template',
        'template_params': 'templateParams',
        'preferences': 'preferences'
    }

    def __init__(self, name=None, id=None, language=None, template=None, template_params=None, preferences=None, local_vars_configuration=None):  # noqa: E501
        """LiltCreateContent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._id = None
        self._language = None
        self._template = None
        self._template_params = None
        self._preferences = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        self.language = language
        self.template = template
        self.template_params = template_params
        if preferences is not None:
            self.preferences = preferences

    @property
    def name(self):
        """Gets the name of this LiltCreateContent.  # noqa: E501

        A name for the request content.  # noqa: E501

        :return: The name of this LiltCreateContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LiltCreateContent.

        A name for the request content.  # noqa: E501

        :param name: The name of this LiltCreateContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def id(self):
        """Gets the id of this LiltCreateContent.  # noqa: E501

        A unique identifier for the generated content.  # noqa: E501

        :return: The id of this LiltCreateContent.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LiltCreateContent.

        A unique identifier for the generated content.  # noqa: E501

        :param id: The id of this LiltCreateContent.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def language(self):
        """Gets the language of this LiltCreateContent.  # noqa: E501

        The language of the content.  # noqa: E501

        :return: The language of this LiltCreateContent.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this LiltCreateContent.

        The language of the content.  # noqa: E501

        :param language: The language of this LiltCreateContent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and language is None:  # noqa: E501
            raise ValueError("Invalid value for `language`, must not be `None`")  # noqa: E501

        self._language = language

    @property
    def template(self):
        """Gets the template of this LiltCreateContent.  # noqa: E501

        The template of the content.  # noqa: E501

        :return: The template of this LiltCreateContent.  # noqa: E501
        :rtype: str
        """
        return self._template

    @template.setter
    def template(self, template):
        """Sets the template of this LiltCreateContent.

        The template of the content.  # noqa: E501

        :param template: The template of this LiltCreateContent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and template is None:  # noqa: E501
            raise ValueError("Invalid value for `template`, must not be `None`")  # noqa: E501

        self._template = template

    @property
    def template_params(self):
        """Gets the template_params of this LiltCreateContent.  # noqa: E501


        :return: The template_params of this LiltCreateContent.  # noqa: E501
        :rtype: LiltCreateContentTemplateParams
        """
        return self._template_params

    @template_params.setter
    def template_params(self, template_params):
        """Sets the template_params of this LiltCreateContent.


        :param template_params: The template_params of this LiltCreateContent.  # noqa: E501
        :type: LiltCreateContentTemplateParams
        """
        if self.local_vars_configuration.client_side_validation and template_params is None:  # noqa: E501
            raise ValueError("Invalid value for `template_params`, must not be `None`")  # noqa: E501

        self._template_params = template_params

    @property
    def preferences(self):
        """Gets the preferences of this LiltCreateContent.  # noqa: E501


        :return: The preferences of this LiltCreateContent.  # noqa: E501
        :rtype: LiltCreateContentPreferences
        """
        return self._preferences

    @preferences.setter
    def preferences(self, preferences):
        """Sets the preferences of this LiltCreateContent.


        :param preferences: The preferences of this LiltCreateContent.  # noqa: E501
        :type: LiltCreateContentPreferences
        """

        self._preferences = preferences

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LiltCreateContent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LiltCreateContent):
            return True

        return self.to_dict() != other.to_dict()
